﻿Imports System.Runtime.InteropServices

Public Class Form1
    Private Const IOCTL_GPIO_SET_PIN_CONFIGURATION As Integer = 262144
    Private Const IOCTL_GPIO_SET_PIN_OUTPUT_VALUE As Integer = 262148
    Private Const IOCTL_GPIO_GET_PIN_INPUT_VALUE As Integer = 262152

    Dim bytePtr As IntPtr

    Friend Enum GPIO_PORT As Integer
        PORT_A = 0
        PORT_B = 1
        PORT_C = 2
        PORT_D = 3
        PORT_E = 4
        PORT_F = 5
        PORT_G = 6
        PORT_H = 7
        PORT_I = 8
        PORT_J = 9
        PORT_K = 10
        PORT_L = 11
        PORT_M = 12
        PORT_N = 13
        PORT_O = 14
        PORT_P = 15
        PORT_Q = 16
    End Enum

    Friend Enum GPIO_PIN_CONFIGURATION As Integer
        OUTPUT = 0
        INPUT_WITH_PULLUP = 1
        INPUT_WITHOUT_PULLUP = 2
        INPUT_WITH_PULLDOWN = 3
    End Enum

    Friend Enum GPIO_PIN_VALUE As Integer
        LOW = 0
        HIGH = 1
    End Enum

    <StructLayout(LayoutKind.Explicit)> _
       Friend Structure GPIO_SET_PIN_CONFIGURATION
        <FieldOffset(0)> Public portNumber As GPIO_PORT
        <FieldOffset(4)> Public pinNumber As Integer
        <FieldOffset(8)> Public pinConfiguration As GPIO_PIN_CONFIGURATION
        <FieldOffset(12)> Public pinValue As GPIO_PIN_VALUE
    End Structure

    <StructLayout(LayoutKind.Explicit)> _
       Friend Structure GPIO_SET_PIN_OUTPUT_VALUE
        <FieldOffset(0)> Public portNumber As GPIO_PORT
        <FieldOffset(4)> Public pinNumber As Integer
        <FieldOffset(8)> Public pinValue As GPIO_PIN_VALUE
    End Structure

    <StructLayout(LayoutKind.Explicit)> _
       Friend Structure GPIO_GET_PIN_OUTPUT_VALUE
        <FieldOffset(0)> Public portNumber As GPIO_PORT
        <FieldOffset(4)> Public pinNumber As Integer
        <FieldOffset(8)> Public pinValue As GPIO_PIN_VALUE
    End Structure


    <DllImport("coredll.dll")> _
    Public Shared Function DeviceIoControl(ByVal hDevice As Integer, ByVal dwIoControlCode As Integer, ByVal lpInBuffer As IntPtr, ByVal nInBufferSize As Integer, ByVal lpOutBuffer As Byte(), ByVal nOutBufferSize As Integer, ByRef lpBytesReturned As Integer, ByVal lpOverlapped As IntPtr) As Integer
    End Function

    <DllImport("coredll.dll")> _
    Public Shared Function CreateFile(ByVal lpFileName As String, ByVal dwDesiredAccess As UInteger, ByVal dwShareMode As UInteger, ByVal lpSecurityAttributes As IntPtr, ByVal dwCreationDisposition As UInteger, ByVal dwFlagsAndAttributes As UInteger, ByVal hTemplateFile As IntPtr) As IntPtr
    End Function

    Private Shared _gpioFile As IntPtr = CreateFile("GPI0:", &H40000000, 0, IntPtr.Zero, 3, 0, IntPtr.Zero)

    Dim ledValues(4) As Byte
    Dim ledInputNumber(4) As Byte
    Dim ledInputPort(4) As GPIO_PORT

    Dim inputNumbers(4) As Integer
    Dim checkStates(4) As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        toggleLed(0)
        If (ledValues(0) = 1) Then
            Button1.Text = "LED 1 ON"
        Else
            Button1.Text = "LED 1 OFF"
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        toggleLed(1)
        If (ledValues(1) = 1) Then
            Button2.Text = "LED 2 ON"
        Else
            Button2.Text = "LED 2 OFF"
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        toggleLed(2)
        If (ledValues(2) = 1) Then
            Button3.Text = "LED 3 ON"
        Else
            Button3.Text = "LED 3 OFF"
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        toggleLed(3)
        If (ledValues(3) = 1) Then
            Button4.Text = "LED 4 ON"
        Else
            Button4.Text = "LED 4 OFF"
        End If
    End Sub

    Private Sub Form1_Closed(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Closed
        Marshal.FreeHGlobal(bytePtr)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim accessType As Integer = 1
        Dim size(4) As Byte
        Dim pinConfig As GPIO_SET_PIN_CONFIGURATION

        ' Allocate a block of unmanaged memory to receive the structure
        bytePtr = Marshal.AllocHGlobal(16)

        'mini6410 board
        ledInputPort(0) = GPIO_PORT.PORT_K
        ledInputNumber(0) = 4
        ledInputPort(1) = GPIO_PORT.PORT_K
        ledInputNumber(1) = 5
        ledInputPort(2) = GPIO_PORT.PORT_K
        ledInputNumber(2) = 6
        ledInputPort(3) = GPIO_PORT.PORT_K
        ledInputNumber(3) = 7

        ' IDEA6410 board
        'ledInputPort(0) = GPIO_PORT.PORT_M
        'ledInputNumber(0) = 0
        'ledInputPort(1) = GPIO_PORT.PORT_M
        'ledInputNumber(1) = 1
        'ledInputPort(2) = GPIO_PORT.PORT_M
        'ledInputNumber(2) = 2
        'ledInputPort(3) = GPIO_PORT.PORT_M
        'ledInputNumber(3) = 3

        For i = 0 To 4
            pinConfig.pinConfiguration = GPIO_PIN_CONFIGURATION.OUTPUT
            pinConfig.pinValue = GPIO_PIN_VALUE.LOW
            pinConfig.portNumber = ledInputPort(i)
            ledValues(i) = 0
            pinConfig.pinNumber = ledInputNumber(i)

            ' Copy the structure to the memory block
            Marshal.StructureToPtr(pinConfig, bytePtr, False)

            DeviceIoControl(_gpioFile, IOCTL_GPIO_SET_PIN_CONFIGURATION, bytePtr, 16, size, 0, accessType, IntPtr.Zero)
        Next

        Button1.Text = "LED 1 OFF"
        Button2.Text = "LED 2 OFF"
        Button3.Text = "LED 3 OFF"
        Button4.Text = "LED 4 OFF"

        ' inputs initialization
        inputNumbers(0) = 0
        inputNumbers(1) = 1
        inputNumbers(2) = 2
        inputNumbers(3) = 3

        pinConfig.portNumber = GPIO_PORT.PORT_N
        pinConfig.pinConfiguration = GPIO_PIN_CONFIGURATION.INPUT_WITHOUT_PULLUP
        For cpt = 0 To 3
            pinConfig.pinNumber = inputNumbers(cpt)
            ' Copy the structure to the memory block
            Marshal.StructureToPtr(pinConfig, bytePtr, False)
            DeviceIoControl(_gpioFile, IOCTL_GPIO_SET_PIN_CONFIGURATION, bytePtr, 16, size, 0, accessType, IntPtr.Zero)
        Next

        CheckBox1.Text = "Button 1"
        CheckBox2.Text = "Button 2"
        CheckBox3.Text = "Button 3"
        CheckBox4.Text = "Button 4"

    End Sub

    Private Sub toggleLed(ByVal ledNumber As Byte)
        Dim accessType As Integer = 1
        Dim pinConfig(13) As Byte
        Dim size(4) As Byte
        Dim pinValue As GPIO_SET_PIN_OUTPUT_VALUE

        If (ledValues(ledNumber) = 1) Then
            ledValues(ledNumber) = 0
            pinValue.pinValue = GPIO_PIN_VALUE.LOW
        Else
            ledValues(ledNumber) = 1
            pinValue.pinValue = GPIO_PIN_VALUE.HIGH
        End If
        pinValue.portNumber = ledInputPort(ledNumber)
        pinValue.pinNumber = ledInputNumber(ledNumber)

        ' Copy the structure to the memory block
        Marshal.StructureToPtr(pinValue, bytePtr, False)

        DeviceIoControl(_gpioFile, IOCTL_GPIO_SET_PIN_OUTPUT_VALUE, bytePtr, 12, size, 0, accessType, IntPtr.Zero)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim pinValue As GPIO_GET_PIN_OUTPUT_VALUE
        Dim pinValueRead As GPIO_GET_PIN_OUTPUT_VALUE
        Dim cpt As Integer
        Dim accessType As Integer = 1
        Dim size(4) As Byte

        pinValue.portNumber = GPIO_PORT.PORT_N

        For cpt = 0 To 3
            pinValue.pinNumber = inputNumbers(cpt)
            ' Copy the structure to the memory block
            Marshal.StructureToPtr(pinValue, bytePtr, False)
            DeviceIoControl(_gpioFile, IOCTL_GPIO_GET_PIN_INPUT_VALUE, bytePtr, 12, size, 0, accessType, IntPtr.Zero)
            ' copy the memory block to the structure
            pinValueRead = CType(Marshal.PtrToStructure(bytePtr, GetType(GPIO_GET_PIN_OUTPUT_VALUE)), GPIO_GET_PIN_OUTPUT_VALUE)
            If (pinValueRead.pinValue = GPIO_PIN_VALUE.HIGH) Then
                checkStates(cpt) = 1
            Else
                checkStates(cpt) = 0
            End If
        Next

        If (checkStates(0) = 1) Then
            CheckBox1.CheckState = CheckState.Checked
        Else
            CheckBox1.CheckState = CheckState.Unchecked
        End If
        If (checkStates(1) = 1) Then
            CheckBox2.CheckState = CheckState.Checked
        Else
            CheckBox2.CheckState = CheckState.Unchecked
        End If
        If (checkStates(2) = 1) Then
            CheckBox3.CheckState = CheckState.Checked
        Else
            CheckBox3.CheckState = CheckState.Unchecked
        End If
        If (checkStates(3) = 1) Then
            CheckBox4.CheckState = CheckState.Checked
        Else
            CheckBox4.CheckState = CheckState.Unchecked
        End If
    End Sub
End Class
